var localBibliography = {
    "JSON-LD": "Manu Sporny, Gregg Kellogg, Markus Lanthaler, Editors. <cite><a href=\"http://www.w3.org/TR/json-ld/\">JSON-LD 1.0</a></cite>. 16 January 2014. W3C Recommendation. URL: <a href=\"http://www.w3.org/TR/json-ld/\">http://www.w3.org/TR/json-ld/</a>",
    "JSON-LD-API": "Markus Lanthaler, Gregg Kellogg, Manu Sporny, Editors. <cite><a href=\"http://www.w3.org/TR/json-ld-api/\">JSON-LD 1.0 Processing Algorithms and API</a></cite>. 16 January 2014. W3C Recommendation. URL: <a href=\"http://www.w3.org/TR/json-ld-api/\">http://www.w3.org/TR/json-ld-api/</a>",
    "JSON-LD-TESTS": "<cite><a href=\"http://www.w3.org/2013/json-ld-tests/\">JSON-LD 1.0 Test Suite</a></cite>. W3C Test Suite. URL: <a href=\"http://www.w3.org/2013/json-ld-tests/\">http://www.w3.org/2013/json-ld-tests/</a>",
    "RDF11-CONCEPTS": "Richard Cyganiak, David Wood, Markus Lanthaler. <cite><a href=\"http://www.w3.org/TR/2014/REC-rdf11-concepts-20140225/\">RDF 1.1 Concepts and Abstract Syntax.</a></cite> W3C Recommendation, 25 February 2014. URL: <a href=\"http://www.w3.org/TR/2014/REC-rdf11-concepts-20140225/\">http://www.w3.org/TR/2014/REC-rdf11-concepts-20140225/</a>. The latest edition is available at <a href=\"http://www.w3.org/TR/rdf11-concepts/\">http://www.w3.org/TR/rdf11-concepts/</a>",
    "RDF11-MT": "Patrick J. Hayes, Peter F. Patel-Schneider. <cite><a href=\"http://www.w3.org/TR/2014/REC-rdf11-mt-20140225/\">RDF 1.1 Semantics.</a></cite> W3C Recommendation, 25 February 2014. URL: <a href=\"http://www.w3.org/TR/2014/REC-rdf11-mt-20140225/\">http://www.w3.org/TR/2014/REC-rdf11-mt-20140225/</a>. The latest edition is available at <a href=\"http://www.w3.org/TR/rdf11-mt/\">http://www.w3.org/TR/rdf11-mt/</a>",
    "TURTLE": "Eric Prud'hommeaux, Gavin Carothers. <cite><a href=\"http://www.w3.org/TR/2014/REC-turtle-20140225/\">RDF 1.1 Turtle: Terse RDF Triple Language.</a></cite> W3C Recommendation, 25 February 2014. URL: <a href=\"http://www.w3.org/TR/2014/REC-turtle-20140225/\">http://www.w3.org/TR/2014/REC-turtle-20140225/</a>. The latest edition is available at <a href=\"http://www.w3.org/TR/turtle/\">http://www.w3.org/TR/turtle/</a>",
    "TRIG": "Gavin Carothers, Andy Seaborne. <cite><a href=\"http://www.w3.org/TR/2014/REC-trig-20140225/\">TriG: RDF Dataset Language</a></cite>. W3C Recommendation, 25 February 2014. URL: <a href=\"http://www.w3.org/TR/2014/REC-trig-20140225/\">http://www.w3.org/TR/2014/REC-trig-20140225/</a>. The latest edition is available at <a href=\"http://www.w3.org/TR/trig/\">http://www.w3.org/TR/trig/</a>",
    "N-TRIPLES": "Gavin Carothers, Andy Seabourne. <cite><a href=\"http://www.w3.org/TR/2014/REC-n-triples-20140225/\">RDF 1.1 N-Triples</cite></a></cite>. W3C Recommendation, 25 February 2014. URL: <a href=\"http://www.w3.org/TR/2014/REC-n-triples-20140225/\">http://www.w3.org/TR/2014/REC-n-triples-20140225/</a>. The latest edition is available at <a href=\"http://www.w3.org/TR/n-triples/\">http://www.w3.org/TR/n-triples/</a>",
    "N-QUADS": "Gavin Carothers. <cite><a href=\"http://www.w3.org/TR/2014/REC-n-quads-20140225/\">RDF 1.1 N-Quads</cite></a></cite>. W3C Recommendation, 25 February 2014. URL: <a href=\"http://www.w3.org/TR/2014/REC-n-quads-20140225/\">http://www.w3.org/TR/2014/REC-n-quads-20140225/</a>. The latest edition is available at <a href=\"http://www.w3.org/TR/n-quads/\">http://www.w3.org/TR/n-quads/</a>",
    "RDF11-XML": "Fabien Gandon, Guus Schreiber. <cite><a href=\"http://www.w3.org/TR/2014/REC-rdf-syntax-grammar-20140225/\">RDF 1.1 XML Syntax</a></cite>. W3C Recommendation, 25 February 2014. URL: <a href=\"http://www.w3.org/TR/2014/REC-rdf-syntax-grammar-20140225/\">http://www.w3.org/TR/2014/REC-rdf-syntax-grammar-20140225/</a>. The latest published version is available at <a href=\"http://www.w3.org/TR/rdf-syntax-grammar/\">http://www.w3.org/TR/rdf-syntax-grammar/</a>.",
    "RDF11-SCHEMA": "Dan Brickley, R. V. Guha. <cite><a href=\"http://www.w3.org/TR/2014/REC-rdf-schema-20140225/\">RDF Schema 1.1</a></cite>. W3C Recommendation, 25 February 2014. URL: <a href=\"http://www.w3.org/TR/2014/REC-rdf-schema-20140225/\">http://www.w3.org/TR/2014/REC-rdf-schema-20140225/</a>. The latest published version is available at <a href=\"http://www.w3.org/TR/rdf-schema/\">http://www.w3.org/TR/rdf-schema/</a>.",
    "RDF11-TESTCASES": "Gregg Kellogg, Markus Lanthaler. <cite><a href=\"http://www.w3.org/TR/2014/NOTE-rdf11-testcases-20140225/\">RDF 1.1 Test Cases</a></cite>. W3C Working Group Note, 25 February 2014. The latest published version is available at <a href=\"http://www.w3.org/TR/rdf11-testcases/\">http://www.w3.org/TR/rdf11-testcases/</a>.",
    "RDF11-PRIMER": "Guus Schreiber, Yves Raimond. <cite><a href=\"http://www.w3.org/TR/2014/NOTE-rdf11-primer-20140225/\">RDF 1.1 Primer</a></cite>. W3C Working Group Note, 25 February 2014. The latest version is available at <a href=\"http://www.w3.org/TR/rdf11-primer/\">http://www.w3.org/TR/rdf11-primer/</a>.",
    "RDF11-NEW": "David Wood. <cite><a href=\"http://www.w3.org/TR/2014/NOTE-rdf11-new-20140225/\">What’s New in RDF 1.1</a></cite>. W3C Working Group Note, 25 February 2014. The latest version is available at <a href=\"http://www.w3.org/TR/rdf11-new/\">http://www.w3.org/TR/rdf11-new/</a>.",
    "RDF11-DATASETS": "Antoine Zimmermann. <cite><a href=\"http://www.w3.org/TR/2014/NOTE-rdf11-datasets-20140225/\">RDF 1.1: On Semantics of RDF Datasets</a></cite>. W3C Working Group Note, 25 February 2014. The latest version is available at <a href=\"http://www.w3.org/TR/rdf11-datasets/\">http://www.w3.org/TR/rdf11-datasets/</a>.",
    "RDFMS": "Ora Lassila; Ralph R. Swick. <cite><a href=\"http://www.w3.org/TR/1999/REC-rdf-syntax-19990222/\">Resource Description Framework (RDF) Model and Syntax Specification</a></cite>. 22 February 1999. W3C Recommendation. URL: <a href=\"http://www.w3.org/TR/1999/REC-rdf-syntax-19990222/\">http://www.w3.org/TR/1999/REC-rdf-syntax-19990222</a>.",
    "LINKED-DATA": "Tim Berners-Lee. <cite><a href=\"http://www.w3.org/DesignIssues/LinkedData.html\">Linked Data</a></cite>. Personal View, imperfect but published. URL: <a href=\"http://www.w3.org/DesignIssues/LinkedData.html\">http://www.w3.org/DesignIssues/LinkedData.html</a>",
    "BERNERS-LEE98": "Tim Berners-Lee. <cite><a href=\"http://www.w3.org/DesignIssues/RDFnot.html\">What the Semantic Web can represent</a></cite>. 1998. URI: <a href=\"http://www.w3.org/DesignIssues/RDFnot.html\">http://www.w3.org/DesignIssues/RDFnot.html</a>.",
    "HORST04": "Herman J. ter Horst. <cite>Extending the RDFS Entailment Lemma</cite>, in S.A. McIlraith et al. (Eds.), The Semantic Web - ISWC2004, Proceedings of the Third International Semantic Web Conference, Hiroshima, Japan, November 2004, Springer, LNCS 3298, pp. 77-91.",
    "HORST05": "Herman J. ter Horst. <cite>Completeness, Decidability and Complexity of Entailment for RDF Schema and a Semantic Extension Involving the OWL Vocabulary</cite>, Journal of Web Semantics 3 (2005) 79-115.",
    "RDF-PLAIN-LITERAL": "Jie Bao, Sandro Hawke, Boris Motik, Peter F. Patel-Schneider, Alex Polleres. <cite><a href=\"http://www.w3.org/TR/rdf-plain-literal/\">rdf:PlainLiteral: A Datatype for RDF Plain Literals (Second Edition)</a></cite> 11 December 2012. W3C Recommendation. URL: <a href=\"http://www.w3.org/TR/rdf-plain-literal/\">http://www.w3.org/TR/rdf-plain-literal/</a>",
    "ISO24707": "<cite>Information technology — Common Logic (CL): a framework for a family of logic-based languages</cite> 1 October 2007. International Standard ISO/IEC 24707:2007(E). URL: <a href=\"http://standards.iso.org/ittf/PubliclyAvailableStandards/c039175_ISO_IEC_24707_2007%28E%29.zip\"> http://standards.iso.org/ittf/PubliclyAvailableStandards/c039175_ISO_IEC_24707_2007%28E%29.zip</a>",
    "EBNF-NOTATION": "Tim Bray; Jean Paoli; C. M. Sperberg-McQueen; Eve Maler; François Yergeau. <a href=\"http://www.w3.org/TR/REC-xml/#sec-notation\"><cite>EBNF Notation</cite></a> 26 November 2008. W3C Recommendation. URL: <a href=\"http://www.w3.org/TR/REC-xml/#sec-notation\">http://www.w3.org/TR/REC-xml/#sec-notation</a>",
    "DOAP": "Ed Dumbill. <cite><a href=\"https://github.com/edumbill/doap/wiki\">Description of a Project.</a></cite> Community Specification. URL: <a href=\"https://github.com/edumbill/doap/wiki\">https://github.com/edumbill/doap/wiki</a>",
    "RELAXNG": "James Clark and Murata Makoto, editors. <cite><a href=\"http://www.oasis-open.org/committees/relax-ng/spec-20011203.html\">RELAX NG Specification</a></cite>. OASIS Committee Specification, 3 December 2001. Latest version: <a href=\"http://www.oasis-open.org/committees/relax-ng/spec.html\">http://www.oasis-open.org/committees/relax-ng/spec.html</a>.",
    "RELAXNG-COMPACT": "James Clark, editor. <cite><a href=\"http://www.oasis-open.org/committees/relax-ng/compact-20021121.html\">RELAX NG Compact Syntax</a></cite>. OASIS Committee Specification, 21 November 2002. URI: <a href=\"http://www.oasis-open.org/committees/relax-ng/compact-20021121.html\">http://www.oasis-open.org/committees/relax-ng/compact-20021121.html</a>.",
    "STRIPEDRDF": "D. Brickley. <cite><a href=\"http://www.w3.org/2001/10/stripes/\">RDF: Understanding the Striped RDF/XML Syntax</a>. W3C, 2001. URI: <a href=\"http://www.w3.org/2001/10/stripes/\">http://www.w3.org/2001/10/stripes/</a>.",
    "IANA-MEDIA-TYPES": "<cite><a href=\"http://www.iana.org/assignments/media-types/\">MIME Media Types</a></cite>. The Internet Assigned Numbers Authority (IANA). The registration for application/rdf+xml is archived at <a href=\"http://www.w3.org/2001/sw/RDFCore/mediatype-registration\">http://www.w3.org/2001/sw/RDFCore/mediatype-registration</a>.",
    "CARROLL-05": "Jeremy J. Carroll, Christian Bizer, Patrick J. Hayes and Patrick Stickler. <cite><a href=\"http://wifo5-03.informatik.uni-mannheim.de/bizer/SWTSGuide/carroll-ISWC2004.pdf\">Named Graphs, Provenance and Trust</a></cite>. Proc. 14th Int. Conf. on World Wide Web, WWW 2005, Chiba, Japan, May 10-14, 2005, pp. 613-622.",
    "TEMPORAL-RDF" : "Claudio Guti&eacute;rrez, Carlos A. Hurtado, Alejandro A. Vaisman. <cite>Temporal RDF.</cite> In The Semantic Web: Research and Applications, Second European Semantic Web Conference, ESWC 2005, Heraklion, Crete, Greece, May 29 - June 1, 2005, Proceedings. Springer, LNCS 3532, pp. 93-107",
    "FUZZY-RDF" : "Umberto Straccia. <cite>A Minimal Deductive System for General Fuzzy RDF.</cite> In Web Reasoning and Rule Systems, Third International Conference, RR 2009, Chantilly, VA, USA, October 25-26, 2009, Proceedings. Springer, LNCS 5837, pp. 166-181",
    "ST-RDF" : "Manolis Koubarakis, Kostis Kyzirakos. <cite>Modeling and Querying Metadata in the Semantic Sensor Web: The Model stRDF and the Query Language stSPARQL.</cite> In The Semantic Web: Research and Applications, 7th Extended Semantic Web Conference, ESWC 2010, Heraklion, Crete, Greece, May 30 - June 3, 2010, Proceedings, Part I. Springer, LNCS 6088, pp. 425-439.",
    "ANNOTATED-RDF" : "Octavian Udrea, Diego Reforgiato Recupero, V. S. Subrahmanian. <cite>Annotated RDF.</cite> In The Semantic Web: Research and Applications, 3rd European Semantic Web Conference, ESWC 2006, Budva, Montenegro, June 11-14, 2006, Proceedings. Springer, LNCS 4011, pp. 487-501",
    "DELBRU-ET-AL-2008" : "Renaud Delbru, Axel Polleres, Giovanni Tummarello, Stefan Decker. <cite>Context Dependent Reasoning for Semantic Documents in Sindice.</cite> In Proceedings of the 4th International Workshop on Scalable Semantic Web Knowledge Base Systems (SSWS). Karlsruhe, Germany, 2008.",
    "SPARQL11-OVERVIEW": { aliasOf: "sparql11-overview" },
    "SPARQL11-QUERY": { aliasOf: "sparql11-query" },
    "SPARQL11-ENTAILMENT": { aliasOf: "sparql11-entailment" },
    "SPARQL11-SERVICE-DESCRIPTION": { aliasOf: "sparql11-service-description" },
    "SPARQL11-TEST-CASE" : "Axel Polleres. <cite><a href=\"http://www.w3.org/2009/sparql/docs/tests/README.html\">SPARQL1.1: Test case structure</a></cite> Informal. URL: <a href=\"http://www.w3.org/2009/sparql/docs/tests/README.html\">http://www.w3.org/2009/sparql/docs/tests/README.html</a>",
    "SPARQL11-UPDATE": { aliasOf: "sparql11-update" },
    "XPATH-DATAMODEL-30": { aliasOf: "xpath-datamodel-30" },
    "XPATH-FUNCTIONS-30": { aliasOf: "xpath-functions-30" },
    "VOID": { aliasOf: "void" },
    "VOCAB-ORG": { aliasOf: "vocab-org" },
    "HTML-RDFA": { aliasOf: "html-rdfa" }
};
